=begin
= Ruby/libplot
GNU libplot  ruby 󥿥ե

== Module/Class Hierarchy

  Libplot -+
           |
           +- Libplot::PlotterParams
           |
           +- Libplot::Plotter

= Module Libplot

== 

= Class Libplot::PlotterParams

== Class Methods

--- Libplot::PlotterParams.new()
      PlotterParams 饹֤

== Methods

--- Libplot::PlotterParams#setplparam(parameter, value)
      ѥ᡼ ((|parameter|))  ((|value|)) ꤹ롣

= Class Libplot::Plotter

== Class Methods

--- Libplot::Plotter.new(type, infile, outfile, errfile, plotter_params)
      Plotter 饹֤
      ((|type|)) ˤեμʲΤ줫ǻꤹ롣
      "X", "Xdrawable", "png", "pnm", "gif", "svg", "ai", "ps", "cgm",
      "fig", "pcl", "hpgl", "regis", "tek", "meta"

== Methods

=== λط

--- Libplot::Plotter#openpl()
      ץå(ڡ)򳫻Ϥ롣
      Ԥ硢֤ͤäƤ롣

--- Libplot::Plotter#closepl()
      ץå(ڡ)λ롣
      Ԥ硢֤ͤäƤ롣

--- Libplot::Plotter#erase()
      ץåȤõ롣

--- Libplot::Plotter#flushpl()
      Хåեƽ񤭽ФƤʤץåȤƤեå夹롣
       real-time plotting ʥץå(X Plotters, X Drawable 
      Plotters, ReGIS Plotters, Tektronix Plotters, and Metafile Plotters)
      ΤߤͭǤ롣

--- Libplot::Plotter#havecap(s)
      Plotter ǽϡĴ٤롣
      
=== եå/ɸط

--- Libplot::Plotter#space(x0, y0, x1, y1)
--- Libplot::Plotter#fspace(x0, y0, x1, y1)
      桼ɸ򺸲Ѥκɸ (((|x0|)), ((|y0|)))
      Ѥκɸ (((|x1|)), ((|y1|))) ꤹ롣
      Libplot::Plotter#openpl() ƤӽФľꤹɬפ롣

--- Libplot::Plotter#space2(x0, y0, x1, y1, x2, y2)
--- Libplot::Plotter#fspace2(x0, y0, x1, y1, x2, y2)
      Libplot::Plotter#space γĥ

--- Libplot::Plotter#fsetmatrix(M0, M1, M2, M3, TX, TY)
      Postscript κɸѴ [M0 M1 M2 M3 TX TY]
      Ԥ

--- Libplot::Plotter#fconcat(M0, M1, M2, M3, TX, TY)
      

--- Libplot::Plotter#frotate(theta)
      ɸϤž롣
      [cos(THETA) sin(THETA) -sin(THETA) cos(THETA) 0 0]

--- Libplot::Plotter#fscale(x, y)
      ɸϤ硢̾롣

--- Libplot::Plotter#ftranslate(x, y)
      ɸ (((|x|)), ((|y|))) ꤹ롣

=== եå/ط

--- Libplot::Plotter#move(x, y)
--- Libplot::Plotter#fmove(x, y)
      ȥݥȤɸ (((|x|)), ((|y|))) ˰ư롣

--- Libplot::Plotter#moverel(dx, dy)
--- Libplot::Plotter#fmoverel(dx, dy)
      ȥݥȤкɸ (((|dx|)), ((|dy|))) ˰ư롣

--- Libplot::Plotter#point(x, y)
--- Libplot::Plotter#fpoint(x, y)
      ȥѥλɸ (((|x|)), ((|y|))) 褹롣
      ȥݥȤϺɸ (((|x|)), ((|y|))) ˰ư롣

--- Libplot::Plotter#pointrel(dx, dy)
--- Libplot::Plotter#fpointrel(dx, dy)
      ȥѥλкɸ (((|dx|)), ((|dy|))) 褹롣
      ȥݥȤкɸ (((|dx|)), ((|dy|))) ˰ư롣

--- Libplot::Plotter#cont(x, y)
--- Libplot::Plotter#fcont(x, y)
      ȥݥȤɸ (((|x|)), ((|y|))) 
      ȥݥȤϺɸ (((|x|)), ((|y|))) ˰ư롣

--- Libplot::Plotter#contrel(x, y)
--- Libplot::Plotter#fcontrel(dx, dy)
      ȥݥȤкɸ (((|dx|)), ((|dy|))) 
      ȥݥȤкɸ (((|dx|)), ((|dy|))) ˰ư롣

--- Libplot::Plotter#line(x0, y0, x1, y1)
--- Libplot::Plotter#fline(x0, y0, x1, y1)
      (((|x0|)), ((|y0|)))  (((|x1|)), ((|y1|))) ޤ
      ȥݥȤϺɸ (((|x1|)), ((|y1|))) ˰ư롣

--- Libplot::Plotter#linerel(dx0, dy0, dx1, dy1)
--- Libplot::Plotter#flinerel(dx0, dy0, dx1, dy1)
      (((|x0|)), ((|y0|)))  (((|x1|)), ((|y1|))) ޤ
      ȥݥȤкɸ (((|dx1|)), ((|dy1|))) ˰ư롣

--- Libplot::Plotter#bezier2(x0, y0, x1, y1, x2, y2)
--- Libplot::Plotter#fbezier2(x0, y0, x1, y1, x2, y2)
      ɸ (((|x0|)), ((|y0|))) ɸ (((|x2|)), ((|y2|))) ޤǥ٥
      ɸ (((|x1|)), ((|y1|))) ˤϥ٥ controll points ꤹ롣

--- Libplot::Plotter#bezier2rel(dx0, dy0, dx1, dy1, dx2, dy2)
--- Libplot::Plotter#fbezier2rel(dx0, dy0, dx1, dy1, dx2, dy2)
      кɸ (((|dx0|)), ((|dy0|))) кɸ (((|dx2|)), ((|dy2|))) ޤǥ٥
      кɸ (((|dx1|)), ((|dy1|))) ˤϥ٥ controll points ꤹ롣

--- Libplot::Plotter#bezier3(x0, y0, x1, y1, x2, y2, x3, y3)
--- Libplot::Plotter#fbezier3(x0, y0, x1, y1, x2, y2, x3, y3)
      ɸ (((|x0|)), ((|y0|))) ɸ (((|x3|)), ((|y3|))) ޤǥ٥
      ɸ (((|x1|)), ((|y1|))), (((|x2|)), ((|y2|))) ˤϥ٥ controll points ꤹ롣

--- Libplot::Plotter#bezier3rel(dx0, dy0, dx1, dy1, dx2, dy2, dx3, dy3)
--- Libplot::Plotter#fbezier3rel(dx0, dy0, dx1, dy1, dx2, dy2, dx3, dy3)
      кɸ (((|dx0|)), ((|dy0|))) кɸ (((|dx3|)), ((|dy3|))) ޤǥ٥
      кɸ (((|dx1|)), ((|dy1|))), (((|dx2|)), ((|dy2|))) ˤϥ٥ controll points ꤹ롣

--- Libplot::Plotter#box(x0, y0, x1, y1)
--- Libplot::Plotter#fbox(x0, y0, x1, y1)
      Ѥκɸ (((|x0|)), ((|y0|))) Ѥκɸ (((|x1|)), ((|y1|)))
      λͳѤ
      ȥݥȤϺɸ (((|x1|)), ((|y1|))) ˰ư롣

--- Libplot::Plotter#boxrel(dx0, dy0, dx1, dy1)
--- Libplot::Plotter#fboxrel(dx0, dy0, dx1, dy1)
      Ѥкɸ (((|dx0|)), ((|dy0|))) Ѥкɸ (((|dx1|)), ((|dy1|)))
      λͳѤ
      ȥݥȤкɸ (((|dx1|)), ((|dy1|))) ˰ư롣

--- Libplot::Plotter#circle(x, y, r)
--- Libplot::Plotter#fcircle(x, y, r)
      濴ɸ (((|x|)), ((|y|)))Ⱦ ((|r|)) αߤ

--- Libplot::Plotter#circlerel(dx, dy, r)
--- Libplot::Plotter#fcirclerel(dx, dy, r)
      濴кɸ (((|x|)), ((|y|)))Ⱦ ((|r|)) αߤ

--- Libplot::Plotter#arc(xc, yc, x0, y0, x1, y1)
--- Libplot::Plotter#farc(xc, yc, x0, y0, x1, y1)
      濴ɸ (((|xc|)), ((|yc|)))Ϻɸ (((|x0|)), ((|y0|)))
      λɸ (((|x1|)), ((|y1|)))α߸̤

--- Libplot::Plotter#arcrel(dxc, dyc, dx0, dy0, dx1, dy1)
--- Libplot::Plotter#farcrel(dxc, dyc, dx0, dy0, dx1, dy1)
      濴кɸ (((|dxc|)), ((|dyc|)))кɸ (((|dx0|)), ((|dy0|)))
      λкɸ (((|dx1|)), ((|dy1|)))α߸̤

--- Libplot::Plotter#ellipse(x, y, rx, ry, angle)
--- Libplot::Plotter#fellipse(x, y, rx, ry, angle)
      濴ɸ (((|x|)), ((|y|)))X, YĹ
      줾 ((|rx|)), ((|ry|)) γ ((|angle||)) ʱߤ

--- Libplot::Plotter#ellipserel(dx, dy, rx, ry, angle)
--- Libplot::Plotter#fellipserel(dx, dy, rx, ry, angle)
      濴кɸ (((|dx|)), ((|dy|)))X, YĹ
      줾 ((|rx|)), ((|ry|)) γ ((|angle||)) ʱߤ

--- Libplot::Plotter#ellarc(xc, yc, x0, y0, x1, y1)
--- Libplot::Plotter#fellarc(xc, yc, x0, y0, x1, y1)
      濴ɸ (((|xc|)), ((|yc|)))Ϻɸ (((|x0|)), ((|y0|)))
      λɸ (((|x1|)), ((|y1|)))ʱ߸̡

--- Libplot::Plotter#ellarcrel(dxc, dyc, dx0, dy0, dx1, dy1)
--- Libplot::Plotter#fellarcrel(dxc, dyc, dx0, dy0, dx1, dy1)
      濴кɸ (((|dxc|)), ((|dyc|)))кɸ (((|dx0|)), ((|dy0|)))
      λкɸ (((|dx1|)), ((|dy1|)))ʱ߸̡

=== եå/ޡط

--- Libplot::Plotter#marker(x, y, type, size)
--- Libplot::Plotter#fmarker(x, y, type, size)
      ɸ (((|x|)), ((|y|)))  ((|type|)) ǻꤹ礭 ((|size|)) Υޡ褹롣
      ((|type|)) ˤ 0  31 ޤǻǤ롣

--- Libplot::Plotter#markerrel(dx, dy, type, size)
--- Libplot::Plotter#fmarkerrel(dx, dy, type, size)
      кɸ (((|dx|)), ((|dy|)))  ((|type|)) ǻꤹ礭 ((|size|)) Υޡ褹롣
      ((|type|)) ˤ 0  31 ޤǻǤ롣

=== եå/path ط

--- Libplot::Plotter#closepath()
--- Libplot::Plotter#endpath()
      ȥѥĤ롣

--- Libplot::Plotter#endsubpath()


=== եå/ִط

--- Libplot::Plotter#savestate()
--- Libplot::Plotter#restorestate()
      ߤΥեåطξ֤򥻡֡ꥹȥ롣

=== եå/ط

--- Libplot::Plotter#linewidth(size)
--- Libplot::Plotter#flinewidth(size)
       ((|size|)) ꤹ롣

--- Libplot::Plotter#pentype(level)
      ڥΥ٥ꤹ롣
      ((|level|))  1 ξ pencolor  pencolorname 
      ꤷ褹롣1 ǥեȤˤʤäƤ롣
      ((|level|))  0 ξϥѥ褵ʤ

--- Libplot::Plotter#filltype(level)
      ɤĤ֤٤ꤹ롣
      ((|level|))  0 ξɤĤ֤ʤ0 ǥեȤˤʤäƤ롣
      ((|level|))  0x0000...0xffff Ĥޤ 0...65535 ϰϤǤ롣

--- Libplot::Plotter#linemod(s)
       ((|s|)) ꤹ롣((|s|)) ȤƻǤΤϡ
      "solid", "dotted", "dotdashed", "shortdashed", "longdashed",
      "dotdotdashed", "dotdotdotdashed", "disconnected" Τ줫

        "solid"             --------------------------------
        "dotted"            -   -   -   -   -   -   -   -
        "dotdashed"         ----   -   ----   -   ----   -
        "shortdashed"       ----    ----    ----    ----
        "longdashed"        -------    -------    -------
        "dotdotdashed"      ----   -   -   ----   -   -
        "dotdotdotdashed"   ----   -   -   -   ----   -   -   -

--- Libplot::Plotter#linedash(dashes, offset)
--- Libplot::Plotter#flinedash(dashes, offset)
      Υѥꤹ롣

--- Libplot::Plotter#capmod(s)
      üˡ ((|s|)) ꤹ롣((|s|)) ȤƻǤΤ
      "butt" (ǥե), "round", "projecting" Τ줫

--- Libplot::Plotter#joinmod(s)
      ޤγѤˡ ((|s|)) ꤹ롣((|s|)) Ȥ
      ǤΤ "miter" (ǥե), "round", and "bevel" Τ줫

--- Libplot::Plotter#fillmod(s)
      ɤĤ֤ˡ ((|s|)) ꤹ롣((|s|)) ȤƻǤΤ
      "even-odd"(ǥե), "nonzero-winding" Τ줫

--- Libplot::Plotter#fmiterlimit(limit)
      miter limit  ((|limit|)) ꤹ롣

--- Libplot::Plotter#orientation(direction)
      circles, ellipses, and boxes βžꤹ롣
      ((|direction|))  1 ξϻȿвꡢ
      -1 ξϻײȤʤ롣

=== եå/ط

--- Libplot::Plotter#bgcolor(red, green, blue)
      طʿꤹ롣ͤ 0x0000...0xffff ʤ 0...65535 ϰϤǤ롣
      (0, 0, 0) Ϲ(65535, 65535, 65535) ꤷȤˤʤ롣

--- Libplot::Plotter#bgcolorname(name)
      طʿꤹ롣ǤʤȤߤʤ롣
       24ӥå RGB "#c0c0c0" ǻǤ롣
      ޤ/usr/local/share/libplot/colors.txt ʤɤˤ
      "red", "blue" ʤɤǤǤ롣

--- Libplot::Plotter#color(red, green, blue)
--- Libplot::Plotter#colorname(name)
      ꤹ롣Libplot::Plotter#pencolor  Libplot::Plotter#fillcolor 
      Ʊ˸ƤӽФȤƱǤ롣

--- Libplot::Plotter#fillcolor(red, green, blue)
--- Libplot::Plotter#fillcolorname(name)
      ɤĤ֤ꤹ롣

--- Libplot::Plotter#pencolor(red, green, blue)
--- Libplot::Plotter#pencolorname(name)
      ڥοꤹ롣

=== եȴط

--- Libplot::Plotter#fontname(s)
--- Libplot::Plotter#ffontname(s)
      եȤե̾ ((|s|)) ꤹ롣

--- Libplot::Plotter#fontsize(size)
--- Libplot::Plotter#ffontsize(size)
      եȤ礭 ((|size|)) ꤹ롣

=== ƥȴط

--- Libplot::Plotter#alabel(x_justify, y_justify, s)
      ʸ ((|s|)) 򥫥ȥݥȤ褹롣
      ((|x_justify|))  'l', 'c', 'r' ꤹ뤳Ȥ
      X κ·򤹤롣
      ((|y_justify|))  'b', 'x', 'c', 't' ꤹ뤳Ȥ
      Yβ١饤·򤹤롣

--- Libplot::Plotter#label(s)
      ʸ ((|s|)) 򥫥ȥݥȤ˺ͤ褹롣
      ȥݥȤʸü˰ư롣
      Libplot::Plotter#alabel('l', 'x', s) Ʊ

--- Libplot::Plotter#labelwidth(s)
--- Libplot::Plotter#flabelwidth(s)
      ʸ ((|s|)) Ĺ֤

--- Libplot::Plotter#textangle(angle)
--- Libplot::Plotter#ftextangle(angle)
      ʸ٤ X פȿм ((|angle|)) ꤹ롣
      ȥեȥ֤

=end
