#!/usr/local/bin/ruby
#
# converted from Info Manual
#                Animated GIFs in C
#
# ./test03.rb > test03.gif

require "libplot"

plotter_params = Libplot::PlotterParams.new()

plotter_params.setplparam("BITMAPSIZE", "150x100")
plotter_params.setplparam("BG_COLOR", "orange")
plotter_params.setplparam("TRANSPARENT_COLOR", "orange")
plotter_params.setplparam("GIF_ITERATIONS", "100")
plotter_params.setplparam("GIF_DELAY", "5")

plotter = Libplot::Plotter.new("gif", STDIN, STDOUT, STDERR, plotter_params)

plotter.openpl()
plotter.fspace(-0.5, -0.5, 149.5, 99.5)

plotter.pencolorname("red")
plotter.linewidth(5)
plotter.filltype(1)
plotter.fillcolorname("black")

i = 0
while i < 180
  plotter.erase()
  plotter.ellipse(75, 50, 40, 20, i)
  i += 15
end

plotter.closepl()
#plotter.deletepl()
