#!/usr/local/bin/ruby
#
# converted from Info Manual
#                X Animations in C
#
# ./test05.rb

require "libplot"

angle = 0

plotter_params = Libplot::PlotterParams.new()
plotter_params.setplparam("BITMAPSIZE", "300x300")
plotter_params.setplparam("BG_COLOR", "blue")
plotter_params.setplparam("USE_DOUBLE_BUFFERING", "yes")
#plotter_params.setplparam("USE_DOUBLE_BUFFERING", "no")

plotter = Libplot::Plotter.new("X", STDIN, STDOUT, STDERR, plotter_params)

plotter.openpl()
plotter.fspace(0.0, 0.0, 1.0, 1.0)
plotter.pencolorname("white")
plotter.ffontsize(1.0)
plotter.fontname("NewCenturySchlbk-Roman")

plotter.fmove(0.50, 0.50)

while 1
  plotter.erase()
  angle += 1
  plotter.textangle(angle)
  plotter.alabel('c', 'c', "A")
end

plotter.closepl()
#plotter.deletepl()
